/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class Browser extends javax.swing.JFrame
{

    protected Vector<String> history = new Vector<String>();
    protected String currentURL = "http://unigrids.icm.edu.pl/VisNow_sample_data";
    protected String readButtonTitle = "read VisNow file";
    protected String[] extensions;

    /**
     * Creates new form Browser
     */
    public Browser()
    {
        initComponents();
        backButton.setEnabled(false);
        currentURL = urlField.getText();
        history.add(currentURL);
        setPage(currentURL);
    }

    public Browser(String[] extensions)
    {
        initComponents();
        this.extensions = extensions;
    }

    protected final void setPage(String url)
    {
        try {
            readButton.setEnabled(false);
            for (String extension : extensions) {
                if (url.endsWith(extension))
                    readButton.setEnabled(true);
            }
            browserPane.setPage(url);
        } catch (IOException e) {
        }
    }

    public String getCurrentURL()
    {
        return currentURL;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new JPanel();
        backButton = new JButton();
        urlField = new JTextField();
        goButton = new JButton();
        jScrollPane1 = new JScrollPane();
        browserPane = new JEditorPane();
        readButton = new JButton();

        setMinimumSize(new Dimension(600, 500));

        jPanel2.setBorder(BorderFactory.createEtchedBorder());
        jPanel2.setMinimumSize(new Dimension(100, 28));
        jPanel2.setPreferredSize(new Dimension(400, 28));
        jPanel2.setLayout(new BorderLayout());

        backButton.setFont(new Font("Dialog", 1, 14));
        backButton.setText("<");
        backButton.setMargin(new Insets(2, 2, 2, 2));
        backButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                backButtonActionPerformed(evt);
            }
        });
        jPanel2.add(backButton, BorderLayout.WEST);

        urlField.setText("http://unigrids.icm.edu.pl/VisNow_sample_data");
        urlField.setMinimumSize(new Dimension(4, 22));
        urlField.setPreferredSize(new Dimension(294, 24));
        jPanel2.add(urlField, BorderLayout.CENTER);

        goButton.setText("go");
        goButton.setMargin(new Insets(2, 2, 2, 2));
        goButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                goButtonActionPerformed(evt);
            }
        });
        jPanel2.add(goButton, BorderLayout.LINE_END);

        getContentPane().add(jPanel2, BorderLayout.NORTH);

        browserPane.setEditable(false);
        browserPane.addHyperlinkListener(new HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent evt) {
                browserPaneHyperlinkUpdate(evt);
            }
        });
        jScrollPane1.setViewportView(browserPane);

        getContentPane().add(jScrollPane1, BorderLayout.CENTER);

        readButton.setText("read VisNow file");
        readButton.setEnabled(false);
        readButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                readButtonActionPerformed(evt);
            }
        });
        getContentPane().add(readButton, BorderLayout.PAGE_END);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void goButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_goButtonActionPerformed
    {//GEN-HEADEREND:event_goButtonActionPerformed
        try {
            currentURL = urlField.getText();
            history.add(currentURL);
            setPage(currentURL);
        } catch (Exception ex) {
        }
    }//GEN-LAST:event_goButtonActionPerformed

    private void backButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_backButtonActionPerformed
    {//GEN-HEADEREND:event_backButtonActionPerformed
        try {
            currentURL = history.lastElement();
            history.removeElement(currentURL);
            currentURL = history.lastElement();
            setPage(currentURL);
            urlField.setText(currentURL);
            if (history.size() == 1)
                backButton.setEnabled(false);
        } catch (Exception ex) {
        }
    }//GEN-LAST:event_backButtonActionPerformed

    private void readButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_readButtonActionPerformed
    {//GEN-HEADEREND:event_readButtonActionPerformed
        setVisible(false);
        fireStateChanged();
    }//GEN-LAST:event_readButtonActionPerformed

    private void browserPaneHyperlinkUpdate(HyperlinkEvent evt)//GEN-FIRST:event_browserPaneHyperlinkUpdate
    {//GEN-HEADEREND:event_browserPaneHyperlinkUpdate
        if (evt.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
            try {
                currentURL = evt.getURL().toString();
                history.add(currentURL);
                backButton.setEnabled(true);
                setPage(currentURL);
                urlField.setText(currentURL);
            } catch (Exception e) {
                System.out.println("ERROR: Trouble fetching url");
            }
        }
    }//GEN-LAST:event_browserPaneHyperlinkUpdate

    public void setReadButtonTitle(String title)
    {
        readButtonTitle = title;
        readButton.setText(readButtonTitle);
    }

    public void setExtensions(String[] extensions)
    {
        this.extensions = extensions;
    }

    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList
        = new ArrayList<ChangeListener>();

    /**
     * Registers ChangeListener to receive events.
     * <p/>
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     * <p/>
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     * <p/>
     * @param object Parameter #1 of the
     *               <CODE>ChangeEvent<CODE> constructor.
     */
    private void fireStateChanged()
    {
        ChangeEvent e = new ChangeEvent(this);
        for (ChangeListener listener : changeListenerList)
            listener.stateChanged(e);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JButton backButton;
    private JEditorPane browserPane;
    private JButton goButton;
    private JPanel jPanel2;
    private JScrollPane jScrollPane1;
    private JButton readButton;
    private JTextField urlField;
    // End of variables declaration//GEN-END:variables
}
